package de.humance.eco.profile.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.humance.eco.profile.model.QualificationTypeResource;
import de.humance.eco.profile.model.QualificationTypeResourceModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the QualificationTypeResource service. Represents a row in the &quot;Profile_QualificationTypeResource&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.humance.eco.profile.model.QualificationTypeResourceModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link QualificationTypeResourceImpl}.
 * </p>
 *
 * @author Humance
 * @see QualificationTypeResourceImpl
 * @see de.humance.eco.profile.model.QualificationTypeResource
 * @see de.humance.eco.profile.model.QualificationTypeResourceModel
 * @generated
 */
public class QualificationTypeResourceModelImpl extends BaseModelImpl<QualificationTypeResource>
    implements QualificationTypeResourceModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a qualification type resource model instance should use the {@link de.humance.eco.profile.model.QualificationTypeResource} interface instead.
     */
    public static final String TABLE_NAME = "Profile_QualificationTypeResource";
    public static final Object[][] TABLE_COLUMNS = {
            { "qualificationTypeResourceId", Types.BIGINT },
            { "qualificationTypeId", Types.BIGINT },
            { "country", Types.VARCHAR },
            { "language", Types.VARCHAR },
            { "name", Types.VARCHAR },
            { "description", Types.VARCHAR },
            { "note", Types.VARCHAR },
            { "iconId", Types.BIGINT }
        };
    public static final String TABLE_SQL_CREATE = "create table Profile_QualificationTypeResource (qualificationTypeResourceId LONG not null primary key,qualificationTypeId LONG,country VARCHAR(75) null,language VARCHAR(75) null,name VARCHAR(1000) null,description TEXT null,note VARCHAR(2000) null,iconId LONG)";
    public static final String TABLE_SQL_DROP = "drop table Profile_QualificationTypeResource";
    public static final String ORDER_BY_JPQL = " ORDER BY qualificationTypeResource.qualificationTypeId ASC, qualificationTypeResource.country ASC, qualificationTypeResource.language ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Profile_QualificationTypeResource.qualificationTypeId ASC, Profile_QualificationTypeResource.country ASC, Profile_QualificationTypeResource.language ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.humance.eco.profile.model.QualificationTypeResource"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.humance.eco.profile.model.QualificationTypeResource"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.humance.eco.profile.model.QualificationTypeResource"),
            true);
    public static long COUNTRY_COLUMN_BITMASK = 1L;
    public static long LANGUAGE_COLUMN_BITMASK = 2L;
    public static long QUALIFICATIONTYPEID_COLUMN_BITMASK = 4L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.humance.eco.profile.model.QualificationTypeResource"));
    private static ClassLoader _classLoader = QualificationTypeResource.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            QualificationTypeResource.class
        };
    private long _qualificationTypeResourceId;
    private long _qualificationTypeId;
    private long _originalQualificationTypeId;
    private boolean _setOriginalQualificationTypeId;
    private String _country;
    private String _originalCountry;
    private String _language;
    private String _originalLanguage;
    private String _name;
    private String _description;
    private String _note;
    private long _iconId;
    private long _columnBitmask;
    private QualificationTypeResource _escapedModel;

    public QualificationTypeResourceModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _qualificationTypeResourceId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setQualificationTypeResourceId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _qualificationTypeResourceId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return QualificationTypeResource.class;
    }

    @Override
    public String getModelClassName() {
        return QualificationTypeResource.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("qualificationTypeResourceId",
            getQualificationTypeResourceId());
        attributes.put("qualificationTypeId", getQualificationTypeId());
        attributes.put("country", getCountry());
        attributes.put("language", getLanguage());
        attributes.put("name", getName());
        attributes.put("description", getDescription());
        attributes.put("note", getNote());
        attributes.put("iconId", getIconId());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long qualificationTypeResourceId = (Long) attributes.get(
                "qualificationTypeResourceId");

        if (qualificationTypeResourceId != null) {
            setQualificationTypeResourceId(qualificationTypeResourceId);
        }

        Long qualificationTypeId = (Long) attributes.get("qualificationTypeId");

        if (qualificationTypeId != null) {
            setQualificationTypeId(qualificationTypeId);
        }

        String country = (String) attributes.get("country");

        if (country != null) {
            setCountry(country);
        }

        String language = (String) attributes.get("language");

        if (language != null) {
            setLanguage(language);
        }

        String name = (String) attributes.get("name");

        if (name != null) {
            setName(name);
        }

        String description = (String) attributes.get("description");

        if (description != null) {
            setDescription(description);
        }

        String note = (String) attributes.get("note");

        if (note != null) {
            setNote(note);
        }

        Long iconId = (Long) attributes.get("iconId");

        if (iconId != null) {
            setIconId(iconId);
        }
    }

    @Override
    public long getQualificationTypeResourceId() {
        return _qualificationTypeResourceId;
    }

    @Override
    public void setQualificationTypeResourceId(long qualificationTypeResourceId) {
        _qualificationTypeResourceId = qualificationTypeResourceId;
    }

    @Override
    public long getQualificationTypeId() {
        return _qualificationTypeId;
    }

    @Override
    public void setQualificationTypeId(long qualificationTypeId) {
        _columnBitmask = -1L;

        if (!_setOriginalQualificationTypeId) {
            _setOriginalQualificationTypeId = true;

            _originalQualificationTypeId = _qualificationTypeId;
        }

        _qualificationTypeId = qualificationTypeId;
    }

    public long getOriginalQualificationTypeId() {
        return _originalQualificationTypeId;
    }

    @Override
    public String getCountry() {
        if (_country == null) {
            return StringPool.BLANK;
        } else {
            return _country;
        }
    }

    @Override
    public void setCountry(String country) {
        _columnBitmask = -1L;

        if (_originalCountry == null) {
            _originalCountry = _country;
        }

        _country = country;
    }

    public String getOriginalCountry() {
        return GetterUtil.getString(_originalCountry);
    }

    @Override
    public String getLanguage() {
        if (_language == null) {
            return StringPool.BLANK;
        } else {
            return _language;
        }
    }

    @Override
    public void setLanguage(String language) {
        _columnBitmask = -1L;

        if (_originalLanguage == null) {
            _originalLanguage = _language;
        }

        _language = language;
    }

    public String getOriginalLanguage() {
        return GetterUtil.getString(_originalLanguage);
    }

    @Override
    public String getName() {
        if (_name == null) {
            return StringPool.BLANK;
        } else {
            return _name;
        }
    }

    @Override
    public void setName(String name) {
        _name = name;
    }

    @Override
    public String getDescription() {
        if (_description == null) {
            return StringPool.BLANK;
        } else {
            return _description;
        }
    }

    @Override
    public void setDescription(String description) {
        _description = description;
    }

    @Override
    public String getNote() {
        if (_note == null) {
            return StringPool.BLANK;
        } else {
            return _note;
        }
    }

    @Override
    public void setNote(String note) {
        _note = note;
    }

    @Override
    public long getIconId() {
        return _iconId;
    }

    @Override
    public void setIconId(long iconId) {
        _iconId = iconId;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            QualificationTypeResource.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public QualificationTypeResource toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (QualificationTypeResource) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        QualificationTypeResourceImpl qualificationTypeResourceImpl = new QualificationTypeResourceImpl();

        qualificationTypeResourceImpl.setQualificationTypeResourceId(getQualificationTypeResourceId());
        qualificationTypeResourceImpl.setQualificationTypeId(getQualificationTypeId());
        qualificationTypeResourceImpl.setCountry(getCountry());
        qualificationTypeResourceImpl.setLanguage(getLanguage());
        qualificationTypeResourceImpl.setName(getName());
        qualificationTypeResourceImpl.setDescription(getDescription());
        qualificationTypeResourceImpl.setNote(getNote());
        qualificationTypeResourceImpl.setIconId(getIconId());

        qualificationTypeResourceImpl.resetOriginalValues();

        return qualificationTypeResourceImpl;
    }

    @Override
    public int compareTo(QualificationTypeResource qualificationTypeResource) {
        int value = 0;

        if (getQualificationTypeId() < qualificationTypeResource.getQualificationTypeId()) {
            value = -1;
        } else if (getQualificationTypeId() > qualificationTypeResource.getQualificationTypeId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        value = getCountry()
                    .compareToIgnoreCase(qualificationTypeResource.getCountry());

        if (value != 0) {
            return value;
        }

        value = getLanguage()
                    .compareToIgnoreCase(qualificationTypeResource.getLanguage());

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof QualificationTypeResource)) {
            return false;
        }

        QualificationTypeResource qualificationTypeResource = (QualificationTypeResource) obj;

        long primaryKey = qualificationTypeResource.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        QualificationTypeResourceModelImpl qualificationTypeResourceModelImpl = this;

        qualificationTypeResourceModelImpl._originalQualificationTypeId = qualificationTypeResourceModelImpl._qualificationTypeId;

        qualificationTypeResourceModelImpl._setOriginalQualificationTypeId = false;

        qualificationTypeResourceModelImpl._originalCountry = qualificationTypeResourceModelImpl._country;

        qualificationTypeResourceModelImpl._originalLanguage = qualificationTypeResourceModelImpl._language;

        qualificationTypeResourceModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<QualificationTypeResource> toCacheModel() {
        QualificationTypeResourceCacheModel qualificationTypeResourceCacheModel = new QualificationTypeResourceCacheModel();

        qualificationTypeResourceCacheModel.qualificationTypeResourceId = getQualificationTypeResourceId();

        qualificationTypeResourceCacheModel.qualificationTypeId = getQualificationTypeId();

        qualificationTypeResourceCacheModel.country = getCountry();

        String country = qualificationTypeResourceCacheModel.country;

        if ((country != null) && (country.length() == 0)) {
            qualificationTypeResourceCacheModel.country = null;
        }

        qualificationTypeResourceCacheModel.language = getLanguage();

        String language = qualificationTypeResourceCacheModel.language;

        if ((language != null) && (language.length() == 0)) {
            qualificationTypeResourceCacheModel.language = null;
        }

        qualificationTypeResourceCacheModel.name = getName();

        String name = qualificationTypeResourceCacheModel.name;

        if ((name != null) && (name.length() == 0)) {
            qualificationTypeResourceCacheModel.name = null;
        }

        qualificationTypeResourceCacheModel.description = getDescription();

        String description = qualificationTypeResourceCacheModel.description;

        if ((description != null) && (description.length() == 0)) {
            qualificationTypeResourceCacheModel.description = null;
        }

        qualificationTypeResourceCacheModel.note = getNote();

        String note = qualificationTypeResourceCacheModel.note;

        if ((note != null) && (note.length() == 0)) {
            qualificationTypeResourceCacheModel.note = null;
        }

        qualificationTypeResourceCacheModel.iconId = getIconId();

        return qualificationTypeResourceCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(17);

        sb.append("{qualificationTypeResourceId=");
        sb.append(getQualificationTypeResourceId());
        sb.append(", qualificationTypeId=");
        sb.append(getQualificationTypeId());
        sb.append(", country=");
        sb.append(getCountry());
        sb.append(", language=");
        sb.append(getLanguage());
        sb.append(", name=");
        sb.append(getName());
        sb.append(", description=");
        sb.append(getDescription());
        sb.append(", note=");
        sb.append(getNote());
        sb.append(", iconId=");
        sb.append(getIconId());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(28);

        sb.append("<model><model-name>");
        sb.append("de.humance.eco.profile.model.QualificationTypeResource");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>qualificationTypeResourceId</column-name><column-value><![CDATA[");
        sb.append(getQualificationTypeResourceId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>qualificationTypeId</column-name><column-value><![CDATA[");
        sb.append(getQualificationTypeId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>country</column-name><column-value><![CDATA[");
        sb.append(getCountry());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>language</column-name><column-value><![CDATA[");
        sb.append(getLanguage());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>name</column-name><column-value><![CDATA[");
        sb.append(getName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>description</column-name><column-value><![CDATA[");
        sb.append(getDescription());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>note</column-name><column-value><![CDATA[");
        sb.append(getNote());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>iconId</column-name><column-value><![CDATA[");
        sb.append(getIconId());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
